//********************************************************************
UNIT TestFormUnit;
//********************************************************************

INTERFACE

USES
   Windows, Types, SysUtils, Classes, Controls, ExtCtrls, StdCtrls,
   Forms, Dialogs, Math, dglOpenGl, Terrain;

//********************************************************************
Type
   TTestForm = Class(TForm)
      StartBtn: TButton;
      OGLPanel: TPanel;
    Timer1: TTimer;
      Procedure FormCreate(Sender: TObject);
      Procedure FormDestroy(Sender: TObject);
      Procedure FormResize(Sender: TObject);
      Procedure StartBtnClick(Sender: TObject);
      Procedure Timer1Timer(Sender: TObject);
   Private
      { Private-Deklarationen }
   Public
      { Public-Deklarationen }
   End;

VAR
   TestForm: TTestForm;
//********************************************************************
IMPLEMENTATION
//********************************************************************

{$R *.dfm}

//********************************************************************
VAR
      OGLDeviceContext: HDC;
      OGLRenderingContext: HGLRC;
      OGLWindowHandle: HWND;
      HeightMapLoaded: Boolean;
//********************************************************************
Procedure TTestForm.FormCreate(Sender: TObject);
Begin
   OGLWindowHandle:= OGLPanel.Handle;
   OGLDeviceContext:= GetDC(OGLWindowHandle);
   If InitOpenGL
   Then Begin
      OGLRenderingContext:= CreateRenderingContext
              (OGLDeviceContext,[opDoubleBuffered],32,24,0,0,0,0);
      ActivateRenderingContext(OGLDeviceContext, OGLRenderingContext);
      FormResize(Self);

      InitOpenGLParams;
      HeightMapLoaded:= LoadTGA_8Bit_256X256_HeightMap
                                      ('HeightMap8b_256X256.tga');
   End;                    
End;
//********************************************************************
Procedure TTestForm.FormDestroy(Sender: TObject);
Begin
   FreeTexture;

   DeactivateRenderingContext;
   DestroyRenderingContext(OGLRenderingContext);
   ReleaseDC(OGLWindowHandle, OGLDeviceContext);
End;
//********************************************************************
Procedure TTestForm.FormResize(Sender: TObject);
Begin
   With OGLPanel Do glViewport(0,0,Width,Height);
End;
//********************************************************************
Procedure TTestForm.StartBtnClick(Sender: TObject);
Begin
   If HeightMapLoaded
      Then RenderByOpenGl(OGLDeviceContext);
End;
//********************************************************************
Procedure TTestForm.Timer1Timer(Sender: TObject);
Begin
   If HeightMapLoaded
      Then RenderByOpenGl(OGLDeviceContext);
End;
//********************************************************************
//********************************************************************
End.

